﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;


namespace BPTimer
{
    public partial class Form1 : Form
    {
        int gislot = 0;

        public Form1()
        {
            InitializeComponent();
         }

        PACNET.PAC_CALLBACK_FUNC _timeproc1;
        PACNET.PAC_CALLBACK_FUNC _timeproc2;
        PACNET.PAC_CALLBACK_FUNC _timeproc3;

        int ivalue = 0;
        int gbtrigger = 0;
        int gbtrigger2 = 0;
        int gbtrigger3 = 0;
       
        private int TimeProc3_() //Turn on/off the channel 0
        {  
            if (gbtrigger3==0) //rising edge type
            {
                gbtrigger3 = 1;

                ivalue |= 1;
                PACNET.Sys.slot_outp(gislot, 0, ivalue);
                //pac_slot_outp is a specific API function and it is released for private use
                //pac_slot_outp is a high performance DO write function than pac_WriteDO
            }
            else//falling edge type
            {
                gbtrigger3 = 0;
                ivalue &= (~1);
                PACNET.Sys.slot_outp(gislot, 0, ivalue);
                //pac_slot_outp is a specific API function and it is released for private use
                //pac_slot_outp is a high performance DO write function than pac_WriteDO
            }
            return 0;
        }

        private int TimeProc2_() //Turn on/off the channel 2
        {
            if (gbtrigger2 == 0) //rising edge type
            {

                gbtrigger2 = 1;

                ivalue |= (1<<2);
                PACNET.Sys.slot_outp(gislot, 0, ivalue);
                //pac_slot_outp is a specific API function and it is released for private use
                //pac_slot_outp is a high performance DO write function than pac_WriteDO
            }
            else//falling edge type
            {
                gbtrigger2 = 0;
                ivalue &= (~(1<<2));
                PACNET.Sys.slot_outp(gislot, 0, ivalue);
                //pac_slot_outp is a specific API function and it is released for private use
                //pac_slot_outp is a high performance DO write function than pac_WriteDO
            }
            return 0;
        }

        
        private int TimeProc1_() //Turn on/off the channel 1
        {
            if (gbtrigger == 0) //rising edge type
            {

                gbtrigger = 1;

                ivalue |= (1<<1);
                PACNET.Sys.slot_outp(gislot, 0, ivalue);
                //pac_slot_outp is a specific API function and it is released for private use
                //pac_slot_outp is a high performance DO write function than pac_WriteDO
            }
            else//falling edge type
            {
                gbtrigger = 0;
                ivalue &= (~(1<<1));
                PACNET.Sys.slot_outp(gislot, 0, ivalue);
                //pac_slot_outp is a specific API function and it is released for private use
                //pac_slot_outp is a high performance DO write function than pac_WriteDO
            }
            return 0;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            uint uitimeoutHigh=0;
	        uint uitimeoutLow=0;

            _timeproc3 = TimeProc3_;

	        //Get bp retrigger
	        uitimeoutHigh= Convert.ToUInt16 (textBox1.Text);
            uitimeoutLow= Convert.ToUInt16 (textBox2.Text);

            bool iRet = PACNET.BPTimer.SetBPTimerOut(uitimeoutHigh, uitimeoutLow, _timeproc3);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            iRet = PACNET.BPTimer.SetBPTimerInterruptPriority(0, 100);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            Console.WriteLine("slot =" + gislot + "High =" + uitimeoutHigh + " Low=" + uitimeoutLow);
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            gislot = Convert.ToUInt16 (comboBox1.SelectedIndex); 
        }

        private void button3_Click(object sender, EventArgs e)
        {
            uint uitimeout = 0;

            _timeproc1 = TimeProc1_;

            //Get bp retrigger
            uitimeout = Convert.ToUInt16(textBox3.Text);

            bool iRet = PACNET.BPTimer.SetBPTimer(1, uitimeout, _timeproc1);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            iRet = PACNET.BPTimer.SetBPTimerInterruptPriority(1, 100);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            Console.WriteLine("slot =" + gislot + "uitimeout =" + uitimeout);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            PACNET.BPTimer.KillBPTimer(0);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            PACNET.BPTimer.KillBPTimer(1);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            PACNET.BPTimer.KillBPTimer(2);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            uint uitimeout = 0;

            _timeproc2 = TimeProc2_;

            //Get bp retrigger
            uitimeout = Convert.ToUInt16(textBox4.Text);

            bool iRet = PACNET.BPTimer.SetBPTimer(2, uitimeout, _timeproc2);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            iRet = PACNET.BPTimer.SetBPTimerInterruptPriority(2, 100);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            Console.WriteLine("slot =" + gislot + "uitimeout =" + uitimeout);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox1.SelectedIndex = 2;
        }
    }
}