// CEXML.h: interface for the CCEXML class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CEXML_H__CCE34393_A339_4F76_B1C6_6EE725D4EC68__INCLUDED_)
#define AFX_CEXML_H__CCE34393_A339_4F76_B1C6_6EE725D4EC68__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <objsafe.h>
#include <objbase.h>
#include <msxml2.h>
#include <atlbase.h>


class CCEXML  
{
public:
	CCEXML();
	virtual ~CCEXML();

	BOOL LoadDOM(LPCTSTR szXMLFile);

	//BOOL InitialiseAndParse( LPCTSTR szXMLFile );
	BOOL Initialise( LPCTSTR szXMLFile );
	BOOL Parse();
	BSTR NodesXML(BSTR NotestrQuery,BSTR SingleNodestrQuery);
	BSTR NodeXML(BSTR NotestrQuery);

	CComPtr<IXMLDOMDocument> CCEXML::CreateEmptyDOMDocument();

	// This is a pure virtual function which needs writing by the derived class
	virtual void DisplayChild( IXMLDOMElement* pChild ) = 0 { }
	//virtual void DisplayNode( IXMLDOMNode* pNode ) = 0 { }

	CString ParseXML( IXMLDOMElement *node );
	CString GetAttributes( CString& strAttribs );
	void ProcessNode(int level,IXMLDOMNode *spNode);

	IXMLDOMDocument* GetDocument() { return m_iXMLDoc; }

	void Display( IXMLDOMElement *pChild );

	HRESULT CreateElement(IXMLDOMDocument *pXMLDom, PCWSTR wszName, IXMLDOMElement **ppElement);


	// Helper function to append a child to a parent node.
	HRESULT AppendChildToParent(IXMLDOMNode *pChild, IXMLDOMNode *pParent);


	// Helper function to create and add a processing instruction to a document node.
	HRESULT CreateAndAddPINode(IXMLDOMDocument *pDom, PCWSTR wszTarget, PCWSTR wszData);


	// Helper function to create and add a comment to a document node.
	HRESULT CreateAndAddCommentNode(IXMLDOMDocument *pDom, PCWSTR wszComment);


	// Helper function to create and add an attribute to a parent node.
	HRESULT CreateAndAddAttributeNode(IXMLDOMDocument *pDom, PCWSTR wszName, PCWSTR wszValue, IXMLDOMElement *pParent);

	// Helper function to create and append a text node to a parent node.
	HRESULT CreateAndAddTextNode(IXMLDOMDocument *pDom, PCWSTR wszText, IXMLDOMNode *pParent);

	// Helper function to create and append a CDATA node to a parent node.
	HRESULT CreateAndAddCDATANode(IXMLDOMDocument *pDom, PCWSTR wszCDATA, IXMLDOMNode *pParent);

	// Helper function to create and append an element node to a parent node, and pass the newly created
	// element node to caller if it wants.
	HRESULT CreateAndAddElementNode(IXMLDOMDocument *pDom, PCWSTR wszName, PCWSTR wszNewline, IXMLDOMNode *pParent, IXMLDOMElement **ppElement = NULL);

private:
	void DisplayChildren( IXMLDOMElement* pParent );


protected:
	CComPtr<IXMLDOMDocument> m_iXMLDoc;
};

#endif // !defined(AFX_CEXML_H__CCE34393_A339_4F76_B1C6_6EE725D4EC68__INCLUDED_)
